import akka.actor.ActorRef;
import akka.actor.ActorSystem;
import akka.actor.Props;

import java.io.File;

public class Sample {
 public static int countFiles(final String path) {
    int count = 0;
    File file = new File(path);
    if(file.listFiles() != null) {
      for(File child : file.listFiles()) {
        if(child.isFile())
          count++;
        else
          count += countFiles(child.getPath());
      }
    }

   return count;
 }

 public static void main(String[] args) throws Exception {
   System.out.println("Run a few times so the file system caches results first");
   long start = System.nanoTime();
   final String PATH_OF_INTEREST = "/users/venkats/workarea";
   System.out.println("Number of files is :" + countFiles(PATH_OF_INTEREST));
   long end = System.nanoTime();
   System.out.println("Time taken: " + (end - start)/1.0e9);

   ActorSystem actorSystem = ActorSystem.create();

   ActorRef collector = actorSystem.actorOf(new Props(Collector.class));
   collector.tell(PATH_OF_INTEREST, null);
 }
}
