package com.agiledeveloper;

import akka.actor.UntypedActor;

public class CountAccoumulator extends UntypedActor {
  private int _count = 0;
  private int _expectedMessages = Integer.MAX_VALUE;
  private final long _start = System.nanoTime();

  @Override
  public void onReceive(final Object message) {
    if(message instanceof ExpectedMessages) {
      _expectedMessages = ((ExpectedMessages)(message)).expected;
    }

    if(message instanceof Integer) {
      _count += (Integer)(message);
      _expectedMessages--;
      if(_expectedMessages == 0) {
        final long end = System.nanoTime();
        System.out.println("Count: " + _count);
        System.out.println("Time taken: " + (end - _start)/1.0e9);
        getContext().system().shutdown();
      }
    }
  }
}
